/*
 * RTL Alpha-specific header.
 *
 * Copyright (C) 2000 Cort Dougan <cort@fsmlabs.com>
 */
#ifndef __ALPHA_CONSTANTS_H__
#define __ALPHA_CONSTANTS_H__

#include <asm/irq.h>

#define MACHDEPREGS struct pt_regs *
typedef void intercept_t;  /* intercept returns code determining whether
			      to use linux ret_from intercept */

#define MACHDEPREGS_PTR(x) (x)
#define IRQ_MAX_COUNT NR_IRQS

#define RETURN_FROM_INTERRUPT rtl_return_from_interrupt()

static __inline__ void rtl_return_from_interrupt(void)
{
	unsigned long i;
	extern void ret_from_sys_call(void);
	extern void restore_all(void);
	i = (ulong)&i;
	i += 0x30;
	if ( *(ulong *)i == (ulong)ret_from_sys_call )
	{
		*(ulong *)i = (ulong)restore_all;
		return;
	}
	i += 0x10;
	if ( *(ulong *)i == (ulong)ret_from_sys_call )
	{
		*(ulong *)i = (ulong)restore_all;
		return;
	}
	
	for ( i = (ulong)&i; i <= ((ulong)&i) + sizeof(ulong)*1024;
	      i += sizeof(ulong) )
	{
		if ( *(ulong *)i == (ulong)ret_from_sys_call )
		{
			printk("offset %lx\n", i-((ulong)&i) );
			*(ulong *)i = (ulong)restore_all;
		}
	}
	return;
}

#define RETURN_FROM_INTERRUPT_LINUX return
#define RETURN_FROM_LOCAL return
#define RETURN_FROM_LOCAL_LINUX return

#endif /* __ALPHA_CONSTANTS_H__ */
