/*
 * Copyright (C) 1999 FSM Labs (http://www.fsmlabs.com/)
 *  Written by Cort Dougan <cort@fsmlabs.com>
 *
 */
#ifndef __ARCH_RTL_SYNC__
#define __ARCH_RTL_SYNC__

#include <linux/irq.h>
#include <asm/system.h>
#include <asm/hw_irq.h>

#define rtl_hard_cli() ((void) swpipl(IPL_MAX))
#define rtl_hard_sti() ((void) swpipl(IPL_MIN))
#define rtl_hard_save_flags(x) ((flags) = rdps())
#define rtl_hard_restore_flags(x) ((void) swpipl(x))
#define rtl_hard_savef_and_cli(x) \
	do { rtl_hard_save_flags(x); rtl_hard_cli(); } while(0);
#define	rtl_no_interrupts(s) rtl_hard_savef_and_cli(s)
#define	rtl_restore_interrupts(s) rtl_hard_restore_flags(s)
#define	rtl_stop_interrupts() rtl_hard_cli()
#define	rtl_allow_interrupts() rtl_hard_sti()
#endif
