/*
 * Copyright (C) 1999 FSM Labs (http://www.fsmlabs.com/)
 *  Written by Cort Dougan <cort@fsmlabs.com> and
 *  Victor Yodaiken <yodaiken@fsmlabs.com>
 *
 */
#ifndef __RTL_SYNC__
#define __RTL_SYNC__

#include <arch/rtl_sync.h>

#ifdef __SMP__
#define rtl_spin_lock(x)  { static int z;\
	for(z=0;z<1000000000;z++)\
		if(!test_and_set_bit(0,x.lock)) \
			break;\
	if(z==1000000000){\
		conpr("\nRTLBADSpin=");\
		conprn((unsigned int)&z);\
	}}

#define rtl_spin_unlock(x)   clear_bit(0,x.lock);
#else
#define rtl_spin_lock(x)  
#define rtl_spin_unlock(x)  
#endif

#include <linux/spinlock.h>

#define rtl_spin_lock_irqsave(x, flags) \
	do { rtl_no_interrupts(flags); spin_lock(x); } while (0)
#define rtl_spin_unlock_irqrestore(x, flags) \
	do { spin_unlock(x); rtl_restore_interrupts(flags); } while (0)

#ifdef __SMP__
/* #define rtl_critical(f) {rtl_no_interrupts(f); rtl_spin_lock(&RTL_SPIN_LOCK);} */
/* #define rtl_end_critical(f) {rtl_spin_unlock(&RTL_SPIN_LOCK); rtl_restore_interrupts(f);} */
#define rtl_critical(f) {rtl_spin_lock_irqsave(&RTL_SPIN_LOCK, f);}
#define rtl_end_critical(f) {rtl_spin_unlock_irqrestore(&RTL_SPIN_LOCK, f);}
#else
#define rtl_critical(f) rtl_no_interrupts(f)
#define rtl_end_critical(f) rtl_restore_interrupts(f);
#endif



#endif

