#include <asm/processor.h>
	
#define	r0	0
#define	r1	1
#define	r2	2
#define	r3	3
#define	r4	4
#define	r5	5
#define	r6	6
#define	r7	7
#define	r8	8
#define	r9	9
#define	r10	10
#define	r11	11
#define	r12	12
#define	r13	13
#define	r14	14
#define	r15	15
#define	r16	16
#define	r17	17
#define	r18	18
#define	r19	19
#define	r20	20
#define	r21	21
#define	r22	22
#define	r23	23
#define	r24	24
#define	r25	25
#define	r26	26
#define	r27	27
#define	r28	28
#define	r29	29
#define	r30	30
#define	r31	31
	
	.globl __rtl_init_state
__rtl_init_state:
	lwz	r8,0(r3)	/* get current->stack */
	mr	r7,r8
	subi	r8,r8,4*32
	stmw	r0,0(r8)	/* gprs */
	stw	r7,4(r8)	/* stack - r1 */
	stw	r4,12(r8)	/* fn - r3 */
	stw	r5,16(r8)	/* data - r4 */
	stwu	r6,-4(r8)	/* lr */
	mfctr	r7
	stwu	r7,-4(r8)	/* ctr */
	mfcr	r7
	stwu	r7,-4(r8)	/* cr */
	mfspr	r7,XER
	stwu	r7,-4(r8)	/* xer */
	lis 	r7,MSR_KERNEL@h
	ori 	r7,r7,MSR_KERNEL@l	
	stwu	r7,-4(r8)	/* msr */
	stw	r8,0(r3)	/* store current->stack */
	blr

	.globl __rtl_switch_to
__rtl_switch_to:
	/* hard disable */
	mfmsr	r0
	rlwinm	r0,r0,0,17,15	/* clear MSR_EE in r0 */
	sync
	mtmsr	r0

	/* save old */
	mr	r6,r1
	subi	r6,r6,4*32
	stmw	r0,0(r6)	/* gprs */
	mflr	r5
	stwu	r5,-4(r6)	/* lr */
	mfctr	r5
	stwu	r5,-4(r6)	/* ctr */
	mfcr	r5
	stwu	r5,-4(r6)	/* cr */
	mfxer	r5
	stwu	r5,-4(r6)	/* xer */
	mfmsr	r5
	stwu	r5,-4(r6)	/* msr */
	lwz	r1,0(r3)	/* store current->stack */
	stw	r6,0(r1)

	/* change 'current' */
	stw	r4,0(r3)

	/* restore new */
	lwz	r2,0(r4)	/* get new->stack */
	subi	r2,r2,4		/* predecrement */
	lwzu	r1,4(r2)
	mtspr	SRR1,r1		/* msr */
	lwzu	r1,4(r2)
	mtxer	r1		/* xer */
	lwzu	r1,4(r2)
	mtcr	r1		/* cr */
	lwzu	r1,4(r2)
	mtctr	r1		/* ctr */
	lwzu	r1,4(r2)
	mtspr	SRR0,r1		/* lr */
	addi	r2,r2,4		/* preincrement */
	lmw	r3,12(r2)	/* gprs */
	lwz	r0,0(r2)
	lwz	r1,4(r2)
	lwz	r2,8(r2)

	sync
	isync
	rfi
